const string BUTTON = "../Mods/FancyGUI/DarkMicroStone.png";
const string BUTTON_SELECTED = "../Mods/FancyGUI/SimpleStone.png";
const string WINDOW = "../Mods/FancyGUI/paper.png";



enum skin
{
	button = 0,
	button_pressed,
	window
}

string getSkin(int num)
{
	if(num == 0) return BUTTON;
	if(num == 1) return BUTTON_SELECTED;
	if(num == 2) return WINDOW;

	return WINDOW;//default
}

void DrawRectangle(int skin, Vec2f lCorner, Vec2f rCorner)
{
	const f32 SCALE = 0.5f;
	uint8 tileStep = 16;//32 if scale = 0.5(????16/SCALE???)

	string imgSkin = getSkin(skin);
	rCorner += Vec2f(-tileStep, -tileStep);

	uint width = rCorner.x - lCorner.x;
	uint height = rCorner.y - lCorner.y;

	//f32 width = width - tileStep;
	//f32 height = height - tileStep;
	
	//f32 segment = width;	
	//Vec2f lCorner(pos.x - size.x/2, pos.y  - size.y/2);
	//Vec2f rCorner(lCorner.x + size.x, lCorner.y + size.y);//bottom right corner
	
	//Vec2f lCorner = pos;
	//Vec2f rCorner = pos+size;


	//center area

	uint8 cTileStep = 32;
	f32 cScale = 1.0f;
	for(f32 h_step = tileStep; h_step < height; h_step += cTileStep){
		for(f32 w_step = tileStep; w_step < width; w_step += cTileStep){
			GUI::DrawIcon(imgSkin, 5, Vec2f(16,16), lCorner + Vec2f(w_step,h_step), cScale);	
		}
	}	


	//upper left corner border
	GUI::DrawIcon(imgSkin, 0, Vec2f(16,16), lCorner, SCALE);
	//upper right corner border
	GUI::DrawIcon(imgSkin, 3, Vec2f(16,16), rCorner + Vec2f(0,-height), SCALE);
	//bottom left corner border
	GUI::DrawIcon(imgSkin, 12, Vec2f(16,16), lCorner+ Vec2f(0,+height), SCALE);		
	//bottom right corner border
	GUI::DrawIcon(imgSkin, 15, Vec2f(16,16), rCorner, SCALE);


	//upper border
	for(f32 step = tileStep; step < width; step += tileStep){
		GUI::DrawIcon(imgSkin, 1, Vec2f(16,16), lCorner + Vec2f(step,0), SCALE);
	}

	//bottom border
	for(f32 step = tileStep; step < width; step += tileStep){
		GUI::DrawIcon(imgSkin, 13, Vec2f(16,16), lCorner + Vec2f(step,height), SCALE);
	}

	uint8 frame = 0;
	//left border
	for(f32 step = tileStep; step < height; step += tileStep){
		GUI::DrawIcon(imgSkin, 4+frame, Vec2f(16,16), lCorner + Vec2f(0,step), SCALE);
		if(frame == 0) frame = 4;
		else frame = 0;
	}

	frame = 0;
	//right border
	for(f32 step = tileStep; step < height; step += tileStep){
		GUI::DrawIcon(imgSkin, 7+frame, Vec2f(16,16), rCorner + Vec2f(0,-step), SCALE);
		if(frame == 0) frame = 4;
		else frame = 0;
	}
	
}//end rectangle

void DrawWindow(Vec2f lCorner, Vec2f rCorner)
{

}//end Window

void DrawButton(string label, int skin, Vec2f lCorner, Vec2f rCorner)
{
	DrawRectangle(skin, lCorner, rCorner);
}

void DrawMessageBox(string message, int skin, Vec2f lCorner, Vec2f rCorner)
{
	DrawRectangle(skin,lCorner, rCorner);
	//GUI::DrawText( message ,pos + Vec2f(16,16) , pos+Vec2f(size.x*1.15f,size.y*1.15f), color_black,true,true,false);//Vec2f(size.x*1.15f,size.y*1.15f) BUG??????
	GUI::DrawText( message, lCorner+Vec2f(16,16), rCorner+Vec2f(-16,-16), color_black, true, true, false);
}
