

namespace Fancy
{
	#include "DrawCommon.as"
	shared class Renderable
	{
		string name, icon;
		Vec2f lCorner, rCorner, textPos;
		bool isVisible;
		uint renderPos;//in queue

		void Draw() {};
		bool isCollide(Vec2f curPos)
		{
			if(curPos.x >= lCorner.x && curPos.x <= rCorner.x ){
				if(curPos.y >= lCorner.y && curPos.y <= rCorner.y ){
					return true;
				}
			}
			return false;
		}

	}//end Renderable

	class Button: Renderable
	{/*Button class*/
		bool isPressed = false;

		Button(string name, bool isVisible, Vec2f lCorner, Vec2f rCorner)
		{
			this.name = name;
			this.isVisible = isVisible;
			this.lCorner = lCorner;
			this.rCorner = rCorner;
		}

		void Draw()
		{
			if(!isVisible){ return; }

			uint skin = button;
			if(isPressed) skin = button_pressed;

			DrawButton(name, skin ,lCorner, rCorner);
		}
	}//end Button

	class MessageBox: Renderable
	{/*Message Box class*/
		string message;

		MessageBox(string name, string message, bool isVisible, Vec2f lCorner, Vec2f rCorner)
		{
			this.name = name;
			this.message = message;
			this.isVisible = isVisible;
			this.lCorner = lCorner;
			this.rCorner = rCorner;
		}

		void Draw()
		{
			if(!isVisible){ return; }
			//recti rect( position2di(pos.x, pos.y), position2di(size.x,size.y) );
			//GUI::DrawWindow(Vec2f/);			Vec2f pos = this.pos,
			//Vec2f lCorner(pos.x - size.x/2, pos.y  - size.y/2);
			//Vec2f rCorner(pos.x + size.x, pos.y + size.y);
			

			DrawMessageBox(message, window, lCorner, rCorner);
			//Draw::Rectangle(button, pos, size);
			//GUI::DrawText( "PROBA PERA" ,lCorner, rCorner, color_black, true, true, false );
		}
	}//end MessageBox

	class DrawContainer
	{
		Button@ btn = null;
		MessageBox@ mBox = null;
		uint renderPos;

		DrawContainer(Button@ in_btn, uint pos)
		{
			@btn = @in_btn;
			btn.renderPos = pos;
			this.renderPos = pos;
			//print("Btn "+ pos);
		}

		DrawContainer(MessageBox@ in_mBox, uint pos)
		{
			@mBox = @in_mBox;
			mBox.renderPos = pos;
			this.renderPos = pos;
			//print("Msg "+ pos);

		}
	}//end DrawContainer

	class GUI
	{
		//render queue
		DrawContainer@[] dContainers;

		void addButton(Button@ btn)
		{ 			
			DrawContainer@ container = DrawContainer(btn, dContainers.length());
			dContainers.insertLast( container );
		}
		void addMessageBox(MessageBox@ mBox)
		{			
			DrawContainer@ container = DrawContainer(mBox, dContainers.length());
			dContainers.insertLast( container );
		}
		void Remove(uint index)
		{
			DrawContainer@ container = null;
			
			if(index >= 0 && index < dContainers.length()){
				@container = @dContainers[index];
			}
			else { return; }
			if(container is null){ return; }
			print(""+ (dContainers[index].renderPos == index)); 
			for(uint i = index; i < dContainers.length(); i++){
				dContainers[i].renderPos -= 1;
			}
			print("Index remove "+index);
			dContainers.removeAt(index);
		}
		void Remove(Button@ btn)
		{
			if(btn is null){ return; }
			this.Remove(btn.renderPos);
		}
		void Remove(MessageBox@ mBox)
		{
			if(mBox is null){ return; }
			this.Remove(mBox.renderPos);
		}
		void Clean()
		{
			dContainers.resize(0);
		}
		void RemoveLast()
		{
			if(dContainers.length() > 0){
				dContainers.resize(dContainers.length()-1);
			}
		}
		void Draw()
		{
			if(getNet().isServer()){ return; }
			for (uint i = 0; i < dContainers.length(); i++)
			{
				Button@ btn = dContainers[i].btn;
				MessageBox@ mBox = dContainers[i].mBox;

				if(btn !is null){
					btn.Draw();
				}
				else if(mBox !is null){
					mBox.Draw();
				}
			}
		}
		Button@ getButtonInPos(Vec2f curPos)
		{
			for (uint i = dContainers.length(); i > 0 ; i--)
			{
				print(""+i);
				Button@ btn = dContainers[i-1].btn;

				if(btn !is null){
					if(btn.isCollide(curPos)){
						return btn;//button collided with mouse cursor
					}
				}
			}
			return null;
		}
	}//end GUI

}//end namespace


/////////////////////////////////////////////TESTING AREA//////////////////////////////////////////
Fancy::GUI@ gui = Fancy::GUI();
Fancy::Button@ press_btn;
bool ButtonClicked = false;

void onTick( CRules@ this  )
{	

	CPlayer@ p = getLocalPlayer();
	if (p is null || !p.isMyPlayer()) { return; }

	CControls@ controls = getControls();
	if ( controls.isKeyJustPressed( KEY_KEY_Z) ){
		Fancy::MessageBox@ mBox = Fancy::MessageBox("Test", "Lalalala,s  s d sd \nsd s s s ss s s s s s s s s s s s \ns sdsdaww w w w w  " ,true, Vec2f(100,100), Vec2f(228,356));
		//Fancy::MessageBox@ mBox1 = Fancy::MessageBox("Test1", "jhkjhkjh" ,true,  Vec2f(0,100), Vec2f(300,200));
		//Fancy::MessageBox@ mBox2 = Fancy::MessageBox("Test2", "kjhhkjhhhh g  g g 222" ,true,  Vec2f(400,100), Vec2f(300,200));
		Fancy::Button@ btn = Fancy::Button("BtnTest", true, getDriver().getScreenCenterPos(), getDriver().getScreenCenterPos() + Vec2f(256,128) );
		
		gui.addMessageBox(mBox);
		//gui.addMessageBox(mBox1);
		//gui.addMessageBox(mBox2);

		gui.addButton(btn);
	}
	if ( controls.isKeyJustPressed( KEY_KEY_X) ){
		gui.RemoveLast();
	}

	if(controls.isKeyJustPressed(KEY_LBUTTON)){
		//print("on mouse Click");
		if(gui is null) print("GUI NULL");
		if(press_btn is null) print("press_btn NULL");
		if(controls is null) print("Controls NULL");

		if(gui !is null){ @press_btn = @(gui.getButtonInPos(controls.getMouseScreenPos())); 
			if(press_btn !is null){
				ButtonClicked = true;
				print("Button "+press_btn.name+" was clicked");
				//gui.Remove(press_btn);
			}
		}
	}
	else if(controls.mousePressed1 ){
		if(press_btn !is null){
			if(ButtonClicked) press_btn.isPressed = true;
			else if(press_btn.isPressed) press_btn.isPressed = false;
		}
		//print("on mouse relese");
		//Fancy::DrawRectangle(1, controls.getMouseScreenPos(), controls.getMouseScreenPos() + Vec2f(256,128) );
	}
}

void onRender( CRules@ this )
{
	gui.Draw();
}
//this.getAimPos()